"use strict";
(function($) {
    if(!window.default_pc2sp) {
        var default_pc2sp = 0;
    }
    $(".prop_use_0").on('change init', function() {
        if($(this).prop('checked')) {
            var checked = $(".prop_use_0:checked").val();

            if (checked == 1) {
                $('._simpleOption_pc').hide();
                $('._detailOption_pc').show();
            } else {
                $('._simpleOption_pc').show();
                $('._detailOption_pc').hide();
            }
        }
    }).trigger('init');

    $(".prop_use_1").on('change init', function() {
        if($(this).prop('checked')) {
            var checked = $(".prop_use_1:checked").val();

            if (checked == 1) {
                $('._simpleOption_sp').hide();
                $('._detailOption_sp').show();
            } else {
                $('._simpleOption_sp').show();
                $('._detailOption_sp').hide();
            }
        }
    }).trigger('init');

    /**
     * 各設定画面内のPC/SP切り替え
     */
    var showSettingDevice = function(type, device) {
        if (device == 'pc') {
            type.find('.viewpc').show();
            type.find('.viewsp').hide();
        } else if (device == 'sp') {
            type.find('.viewpc').hide();
            type.find('.viewsp').show();
        }
    }

    $('.deviceTabMenu a').off('click').on('click', function(e) {
        if ($(this).hasClass('active')) {
            return;
        }

        var prefix = $(this).data('prefix');
        var p = $(document);
        var d = $(this).data('device');
        if (prefix) {
            p = $(this).parents('[id^=' + prefix + ']');
        }
        showSettingDevice(p, d);

        p.find('.deviceTabMenu a').removeClass('active hover');
        $(this).addClass('active');

        e.preventDefault();
        e.stopPropagation();
    });
    $('[name=unit_sync]').on('change init', function(e) {
        if($(this).prop('checked')) {
            var sync = $('[name=unit_sync]:checked').val() == 1;
            var bool=true;

            if(sync) {
                if(e.type != 'init') {
                    bool = confirm("リンク状態で保存を行うとSPの設定はPCの設定で上書きされますが宜しいですか");
                }
                if(bool) {
                    $('.deviceTabMenu a:eq(0)').trigger('click');
                    $('.deviceTabMenu a:eq(0) span').html('PC・Tablet・SP');
                    $('.deviceTabMenu li:eq(1)').hide();

                    $('.pc2sp').hide();
                    $('.pc2sp').find('input[type=checkbox]').prop('checked', false);
                } else {
                    $('[name=unit_sync][value=0]').prop('checked', true);
                }
            } else {
                $('.deviceTabMenu a:eq(0) span').text('PC・Tablet');
                $('.deviceTabMenu li:eq(1)').show();

                $('.pc2sp').show();
                $('.pc2sp').find('input[type=checkbox]').prop('checked', ~~default_pc2sp===1);
                if(e.type=="init" && viewmode == "sp") {
                    $('.pc2sp').find('input[type=checkbox]').prop('checked', false);
                }
            }
        }
    }).trigger('init');

    // $('[name=unit_sync]').on('change init', function(e) {
    //     if($(this).prop('checked')) {
    //         var sync = $('[name=unit_sync]:checked').val() == 1;
    //         var bool=true;
    //
    //         if(sync) {
    //             if(e.type != 'init') {
    //                 bool = confirm("リンク状態で保存を行うとSPの設定はPCの設定で上書きされますが宜しいですか");
    //             }
    //             if(bool) {
    //                 $('.deviceTabMenu a:eq(0)').trigger('click');
    //                 $('.deviceTabMenu a:eq(0) span').html('PC・Tablet・SP');
    //                 $('.deviceTabMenu li:eq(1)').hide();
    //             } else {
    //                 $('[name=unit_sync][value=0]').prop('checked', true);
    //             }
    //         } else {
    //             $('.deviceTabMenu a:eq(0) span').text('PC・Tablet');
    //             $('.deviceTabMenu li:eq(1)').show();
    //         }
    //     }
    // }).trigger('init');
})(jQuery);

/******************
 * 以下ユニット用JS
 ******************/
/**
 * スライダー
 */
(function(){
    new InputSlider("#bInputRange1", { min: 1, decimal: 1 });
    new InputSlider("#bInputRange2", { min: 0, decimal: 1 });
    new InputSlider("#bInputRange3", { min: -20, max: 20 });
    new InputSlider("#bInputRange4", { max: 20 });
    new InputSlider("#bInputRange5", { min: -20, max: 20 });
    sp_slider1 = new InputSlider("#bInputRange1_sp", { min: 1, decimal: 1 });
    sp_slider2 = new InputSlider("#bInputRange2_sp", { min: 0, decimal: 1 });
    sp_slider3 = new InputSlider("#bInputRange3_sp", { min: -20, max: 20 });
    sp_slider4 = new InputSlider("#bInputRange4_sp", { max: 20 });
    sp_slider5 = new InputSlider("#bInputRange5_sp", { min: -20, max: 20 });
})();

/**
 * loadイベント
 */
(function($){
    if (viewmode == 'sp') {
        if($("[name=unit_sync]:checked").val()==0) {
            $(".deviceTabMenu").find('[data-device=sp]').trigger('click');
        }
    }
    $(window).on("load", function(){
        FontSelector.setOpenHandler(".bSelecterBtn", {baseurl: bingotopurl,
            callback: function(code, family, style) {
                var self = $(FontSelector.target);
                var name = document.createElement('p');
                var delLink = document.createElement('a');
                var sync = self.data('sync');
                var stylesArray = style.split(";");
                var fontStyle = "";
                $(name).addClass('selectedFontFamily').text(family);
                $(delLink).text('×').addClass('_fontClear').attr({href: 'javascript:void(0);'}).data('sync', sync);

                self.next().remove();
                $(name).append(delLink);
                self.after(name);

                $(sync).val(code);
                FontSelector.reload();

                for(var i = 0; i < stylesArray.length; i++){
                    var m = stylesArray[i].match(/^ *font\-family *: *(.*)/);
                    if(m) {
                        fontStyle = m[1];

                        break;
                    }
                }
            }
        });

        $("#BTNsave").on("click", function(){
            sp_slider1.disable(false);
            sp_slider2.disable(false);
            sp_slider3.disable(false);
            sp_slider4.disable(false);
            sp_slider5.disable(false);
        });

        $('#page-unit-detail').on('click', '._fontClear', function() {
            var sync = j$(this).data('sync');
            j$(sync).val('');
            $(this).parent().remove();
        });
    });
})(jQuery);
