<?php
/**
 * @copyright 2018 Shift Tech Inc All Rights Reserved.
 * @author Shift Tech inc.<https://www.shift-tech.jp/>
 */
require_once(LIB_PATH.'/common/unitCommon.php');

class extChatText extends unitCommon
{
    //------ ユニット毎に必ず設定しなくてはならない変数 -------//
    public $_table = "extunit_chattext";        //公開用テーブル名
    public $_tmptable = "extunit_chattext_tmp";    //下書き用テーブル名
    public $columns = array(
        array("column"=>"pageu_code","conv"=>"n","tags"=>false),
        array("column"=>"name","conv"=>"KVa","tags"=>false),
        array("column"=>"name_color","conv"=>"KVa","tags"=>false),
        array("column"=>"message","conv"=>"KVa","tags"=>true),
        array("column"=>"message_color","conv"=>"KVa","tags"=>false),
        array("column"=>"message_border","conv"=>"KVa","tags"=>false),
        array("column"=>"face_icon","conv"=>"KVa","tags"=>false),
        array("column"=>"face_icon_size","conv"=>"KVa","tags"=>false),
        array("column"=>"layout","conv"=>"text","tags"=>false),
        // array("column"=>"align","conv"=>"a","tags"=>false),
        array("column"=>"fsize","conv"=>"a","tags"=>false),
        array("column"=>"fcolor","conv"=>"a","tags"=>false),
        array("column"=>"ffamily", "conv" => "KVa", "tags" => false),
        array("column"=>"line_height","conv"=>"a","tags"=>false),
        array("column"=>"shadow_x", "conv" => "n", "tags" => false),
        array("column"=>"shadow_y", "conv" => "n", "tags" => false),
        array("column"=>"shadow_blur", "conv" => "n", "tags" => false),
        array("column"=>"shadow_color", "conv" => "KVa", "tags" => false),
        array("column"=>"letterspacing", "conv" => "a", "tags" => false),
        array("column"=>"message_sp","conv"=>"KVa","tags"=>true),
        array("column"=>"message_color_sp","conv"=>"KVa","tags"=>false),
        array("column"=>"message_border_sp","conv"=>"KVa","tags"=>false),
        array("column"=>"face_icon_sp","conv"=>"KVa","tags"=>false),
        array("column"=>"face_icon_size_sp","conv"=>"KVa","tags"=>false),
        array("column"=>"layout_sp","conv"=>"text","tags"=>false),
        // array("column"=>"align_sp","conv"=>"a","tags"=>false),
        array("column"=>"fsize_sp","conv"=>"a","tags"=>false),
        array("column"=>"fcolor_sp","conv"=>"a","tags"=>false),
        array("column"=>"ffamily_sp", "conv" => "KVa", "tags" => false),
        array("column"=>"line_height_sp","conv"=>"a","tags"=>false),
        array("column"=>"shadow_x_sp", "conv" => "n", "tags" => false),
        array("column"=>"shadow_y_sp", "conv" => "n", "tags" => false),
        array("column"=>"shadow_blur_sp", "conv" => "n", "tags" => false),
        array("column"=>"shadow_color_sp", "conv" => "KVa", "tags" => false),
        array("column"=>"letterspacing_sp", "conv" => "a", "tags" => false),

        array("column"=>"use_sp_flg","conv"=>"n","tags"=>false),
        array("column"=>"use_pc_flg","conv"=>"n","tags"=>false),
        array("column"=>"bg_color","conv"=>"n","tags"=>false),        //背景色
        array("column"=>"bdr_type","conv"=>"n","tags"=>false),        //ボーダー
        array("column"=>"btm_padding","conv"=>"n","tags"=>false),      //下方スペース
        array("column"=>"bg_color_sp","conv"=>"n","tags"=>false),     //背景色
        array("column"=>"bdr_type_sp","conv"=>"n","tags"=>false),    //ボーダー
        array("column"=>"btm_padding_sp","conv"=>"n","tags"=>false),   //下方スペース
        array("column"=>"extra_class", "conv" => "as", "tags" => false),  //追加クラス
        array("column"=>"option_extend", "conv" => "n", "tags" => false),  //デザインオプションの継承
        // array("column"=>"anchor_text", "conv" => "KVa", "tags" => false),  //デザインオプションの継承
        array("column"=>"unit_sync", "conv" => "n", "tags" => false),

        array("column"=>"animatecsshelp", "conv" => "KVa", "tags" => false),
        array("column"=>"animatecsshelp_speed", "conv" => "n", "tags" => false),
        array("column"=>"animatecsshelp_delay", "conv" => "n", "tags" => false),
        array("column"=>"animatecsshelp_timing", "conv" => "n", "tags" => false),
    );

    public function __construct()
    {
        unitCommon::__construct();
    }

    //出力データセット処理（必須）
    public function setDisplayData()
    {
        $this->_data = $this->getDetail();
        $props = $this->getProp($this->_pageu_code);
        $this->_view->assign('isSP', 0);
        if (!empty($this->_data)) {
            if ($this->_data['animatecsshelp']!="") {
                $this->_data['extra_class'] .= " attach_anim attach_".$this->_data['animatecsshelp'];
            }

            if ($this->checkSP()) {
                if ($this->_data['unit_sync'] == 1) {
                    //PCを継承時はPCパラメータで上書きしておく
                    $props[1] = $props[0];
                }
                //スマホ時
                if (is_array($props) && isset($props[1])) {
                    $this->_data = array_merge($this->_data, $props[1]);
                }

                if ($this->_data['unit_sync'] != 1) {
                    foreach ($this->_data as $k=>$v) {
                        if ($k=="layout_sp") {
                            continue;
                        }
                        if (strpos($k, "_sp") !== false) {
                            $this->_data[str_replace('_sp', '', $k)] = $v;
                        }
                    }
                }
                $this->_view->assign('isSP', 1);
            } else {
                if (is_array($props) && isset($props[0])) {
                    $this->_data = array_merge($this->_data, $props[0]);
                }
            }

            //テキストスタイル
            $color = null;
            if ($this->_data['fcolor'] != "") {
                $color = "rgba(".$this->_data['fcolor'].")";
            }
            $textStyle = $this->createTextStyle(
                $this->_data['ffamily'],
                $this->_data['fsize'],
                $color,
                $this->_data['line_height'],
                $this->_data['letterspacing'],
                $weight = null,
                $textAlign = null,
                null,
                null,
                null,
                null
            );

            // if (0 < count($textStyle)) {
            //     $this->_data['textStyle'] = implode(' ', $textStyle);
            // }

            $name_style = "";
            if (isset($this->_data['name_color']) && !empty($this->_data['name_color'])) {
                $name_style .= "color: ".$this->_data['name_color'].";";
            }
            if ($name_style != "") {
                $this->_data['nameStyle'] = "style=\"".$name_style."\"";
            }

            $message_style = "";
            if (isset($this->_data['message_color']) && !empty($this->_data['message_color'])) {
                $message_style .= "background-color: ".$this->_data['message_color'].";";
            }
            if (isset($this->_data['shadow_color']) && !empty($this->_data['shadow_color'])) {
                $message_style .= "box-shadow: 0 3px 10px -3px rgba(".$this->_data['shadow_color'].");";
            }
            if (0 < count($textStyle)) {
                $message_style .= implode(' ', $textStyle);
            }

            // if(isset($this->_data['message_border']) && !empty($this->_data['message_border'])) {
            //     $message_style .= "border: 1px solid rgba(".$this->_data['message_border'].");";
            // }
            if ($message_style != "") {
                $this->_data['messageStyle'] = "style=\"".$message_style."\"";
            }

            $unitStyle = $this->createUnitStyle($this->_data);
            if (0 < count($unitStyle)) {
                $this->_data['unitStyle'] = implode(' ', $unitStyle);
            }
            if (version_compare(BINGO_VERSION, '1.7.3', '>=')) {
                $this->_data['unitAttr']=array('style'=>array());
                if ($this->_data['animatecsshelp']!="" && preg_match('/.+Out.*/', $this->_data['animatecsshelp'])) {
                    $this->_data['unitAttr']['style'][] = "visibility: visible;";
                }
                if ($this->_data['animatecsshelp_speed']!="" && is_numeric($this->_data['animatecsshelp_speed'])) {
                    $this->_data['unitAttr']['style'][] = "animation-duration: ".$this->_data['animatecsshelp_speed']."ms;";
                }
                if ($this->_data['animatecsshelp_delay']!="" && is_numeric($this->_data['animatecsshelp_delay'])) {
                    $this->_data['unitAttr']['style'][] = "animation-delay: ".$this->_data['animatecsshelp_delay']."ms;";
                }
                if ($this->_data['animatecsshelp_timing']!="" && is_numeric($this->_data['animatecsshelp_timing'])) {
                    $this->_data['unitAttr']['data-offset'][] = $this->_data['animatecsshelp_timing'];
                }
            }

            //共通プロパティ（余白とか）
            $unitStyle = $this->createUnitStyle($this->_data);
            if (0 < count($unitStyle)) {
                $this->_data['unitStyle'] = implode(' ', $unitStyle);
            }

            $style = "#extChatText".$this->_pageu_code." ._inner._left ._msg:before {
                border-left-color: ".$this->_data['message_color'].";
            }\n";
            $style .= "#extChatText".$this->_pageu_code." ._inner._right ._msg:before {
                border-right-color: ".$this->_data['message_color'].";
            }";
            $this->addStyle($style);

            $this->_data['class'] = $this;
            $this->_view->assign('isAdmin', $this->isAdmin());
            $this->_view->assign('isPrev', $this->_prev);
        }


        //ダミーTPL用
        $this->_view->assign('pageu_code', $this->_pageu_code);

        return $this->_data;
    }

    /**
     * DBより保存データ取得
     * 改変可能
     */
    public function getDetail()
    {
        $rtn =  null;
        $sql = "select * from ".$this->getTbl()." where pageu_code = ?";
        if (isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
            $result = $this->db->prepare($sql, $this->_pageu_code);
            if ($result) {
                $rtn = $result->fetchRow(DB_FETCHMODE_ASSOC);
            }
        }
        return $rtn;
    }


    public function setDefault()
    {
        $this->_data = $this->getDetail();
        $this->_data = $this->getProperty4device($this->_data);
        if ($this->_data) {
            $this->_form->setDefaults($this->_data);

            if ($this->_data['face_icon']) {
                $this->_view->assign('image', BINGOTOPURL.UNITS_IMG_PATH.$this->_data['face_icon']);
            }
            if ($this->_data['face_icon_sp']) {
                $this->_view->assign('image_sp', BINGOTOPURL.UNITS_IMG_PATH.$this->_data['face_icon_sp']);
            }
        } else {
            $this->_data['layout'] = '_left';
            $this->_data['message_color'] = '#ffffff';
            $this->_data['fsize'] = '';
            $this->_data['shadow_x'] = '0';
            $this->_data['shadow_y'] = '0';
            $this->_data['shadow_blur'] = '0';
            $this->_data['shadow_color'] = '0,0,0,0.8';
            $this->_data['message_color_sp'] = '#ffffff';
            $this->_data['fsize_sp'] = '';
            $this->_data['shadow_x_sp'] = '0';
            $this->_data['shadow_y_sp'] = '0';
            $this->_data['shadow_blur_sp'] = '0';
            $this->_data['shadow_color_sp'] = '0,0,0,0.8';
            $this->_data['unit_sync'] = 1;
        }
        $this->_form->setDefaults($this->_data);
    }

    /**
     * フォームエレメントの作成.
     */
    public function setElements()
    {
        $this->_form->addElement('hidden', 'pageu_code', $this->_pageu_code, array('id' => 'pageu_code'));

        $this->_form->addElement('text', 'name', null, array('id' => 'name'));
        $this->_form->addElement('text', 'name_color', null, array('id' => 'name_color'));

        $this->_form->addElement('textarea', 'message', null, array('id' => 'message', 'rows' => '5'));
        $this->_form->addElement('text', 'message_color', null, array('id' => 'message_color color'));
        $this->_form->addElement('text', 'message_border', null, array('id' => 'message_border color'));
        $this->_form->addElement('hidden', 'face_icon', null, array('id' => 'face_icon'));
        $this->_form->addElement('text', 'face_icon_size', null, array('id' => 'face_icon_size', 'class'=>'num numL'));

        $this->_form->addElement('textarea', 'message_sp', null, array('id' => 'message_sp', 'rows' => '5'));
        $this->_form->addElement('text', 'message_color_sp', null, array('id' => 'message_color_sp color'));
        $this->_form->addElement('text', 'message_border_sp', null, array('id' => 'message_border_sp color'));
        $this->_form->addElement('hidden', 'face_icon_sp', null, array('id' => 'face_icon_sp'));
        $this->_form->addElement('text', 'face_icon_size_sp', null, array('id' => 'face_icon_size_sp', 'class'=>'num numL'));

        //レイアウト
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, '<img src="'.BINGOTOPURL.EXT_UNITS_DIR.'/extChatText/admin/left.png">', '_left', array('labelClass' => 'radioBtn', 'style'=>"display:none;")),
            $this->_form->createElement('radio', null, null, '<img src="'.BINGOTOPURL.EXT_UNITS_DIR.'/extChatText/admin/right.png">', '_right', array('labelClass' => 'radioBtn', 'style'=>"display:none;"))
        ), 'layout', '', '');


        //文字サイズ
        $this->_form->addElement('text', 'fsize', null, array('id' => 'fsize', 'class' => 'num numL', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'fsize_sp', null, array('id' => 'fsize_sp', 'class' => 'num numL', 'style' => 'ime-mode:disabled;'));
        //文字色
        $this->_form->addElement('text', 'fcolor', null, array('id' => 'fcolor', 'class' => 'color', 'style' => 'ime-mode:disabled; display:none;'));
        $this->_form->addElement('text', 'fcolor_sp', null, array('id' => 'fcolor_sp', 'class' => 'color', 'style' => 'ime-mode:disabled; display:none;'));
        //行間
        $this->_form->addElement('text', 'line_height', null, array('id' => 'line_height', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'line_height_sp', null, array('id' => 'line_height_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        //文字間
        $this->_form->addElement('text', 'letterspacing', null, array('id' => 'letterspacing', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'letterspacing_sp', null, array('id' => 'letterspacing_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        //テキストフォント
        $this->_form->addElement('hidden', 'ffamily', null, array('id' => 'ffamily'));
        $this->_form->addElement('hidden', 'ffamily_sp', null, array('id' => 'ffamily_sp'));
        //テキストシャドウ
        $this->_form->addElement('text', 'shadow_x', null, array('id' => 'shadow_x', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_y', null, array('id' => 'shadow_y', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_blur', null, array('id' => 'shadow_blur', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_alpha', null, array('id' => 'shadow_alpha', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_color', null, array('id' => 'shadow_color', 'class' => 'color'));

        $this->_form->addElement('text', 'shadow_x_sp', null, array('id' => 'shadow_x_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_y_sp', null, array('id' => 'shadow_y_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_blur_sp', null, array('id' => 'shadow_blur_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_alpha_sp', null, array('id' => 'shadow_alpha_sp', 'class' => 'num', 'style' => 'ime-mode:disabled;'));
        $this->_form->addElement('text', 'shadow_color_sp', null, array('id' => 'shadow_color_sp', 'class' => 'color'));

        //アンカー用テキスト
        $this->_form->addElement('text', 'anchor_text', null, array('id' => 'anchor_text', 'class' => 'txt'));
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, _gettext('しない'), 1, array('labelClass'=>'radioBtn')),
            $this->_form->createElement('radio', null, null, _gettext('する'), 0, array('labelClass'=>'radioBtn')),
        ), 'unit_sync', '', '');

        $fontDB = new fontDB();
        $fonts = $fontDB->getUseFonts($isKey=true);
        $this->_view->addLoadFont($fonts);

        $this->_view->assign('font', $fonts[$this->_data['ffamily']]);
        $this->_view->assign('font_sp', $fonts[$this->_data['ffamily_sp']]);

        if (isset($_POST['animatecsshelp_speed'])) {
            $this->_data['animatecsshelp_speed'] = $_POST['animatecsshelp_speed'];
        }
        if (isset($_POST['animatecsshelp_delay'])) {
            $this->_data['animatecsshelp_delay'] = $_POST['animatecsshelp_delay'];
        }
        if (isset($_POST['animatecsshelp_timing'])) {
            $this->_data['animatecsshelp_timing'] = $_POST['animatecsshelp_timing'];
        }

        $this->_view->assign('data', $this->_data);
    }
    /**
     * フォーム入力エラーチェックの設定.
     */
    public function setRules()
    {
        $this->_form->applyFilter('__ALL__', 'trim');
        $this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues, $this->columns); //ルールに従った値変換、タグの除去
        $this->_form->setJsWarnings(_gettext('B_P00472'), '');

        $this->_form->addRule('pageu_code', _gettext('B_P00643'), 'required', null, $this->erchk);
        $this->_form->addRule('message', 'テキスト(PC)を入力してください', 'required', null, $this->erchk);
        // $this->_form->addRule('face_icon', 'アイコン(PC)を設定してください', 'required', null, $this->erchk);
        $this->_form->addRule('face_icon_size', _gettext('アイコンサイズ(PC)には単位を含んでください。(使用可能な単位：px em rem %)'), 'regex', '/^\d+\.?(\d+)?$|^\d+\.?(\d+)?(px|r?em|%)$/', $this->erchk);
        $this->_form->addRule('fsize', _gettext('フォントサイズ(PC)には単位を含んでください。(使用可能な単位：px em rem %)'), 'regex', '/^\d+\.?(\d+)?$|^\d+\.?(\d+)?(px|r?em|%)$/', $this->erchk);

        $val = $this->_form->getElement('unit_sync')->getValue();
        if ($val != 1 && !isset($_POST['pc2sp']['message'])) {
            $this->_form->addRule('message_sp', 'テキスト(SP)を入力してください', 'required', null, $this->erchk);
        }
        if ($val != 1 && !isset($_POST['pc2sp']['face_icon'])) {
            // $this->_form->addRule('face_icon_sp', 'アイコン(SP)を設定してください', 'required', null, $this->erchk);
        }
        $this->_form->addRule('face_icon_size_sp', _gettext('アイコンサイズ(SP)には単位を含んでください。(使用可能な単位：px em rem %)'), 'regex', '/^\d+\.?(\d+)?$|^\d+\.?(\d+)?(px|r?em|%)$/', $this->erchk);
        $this->_form->addRule('fsize_sp', _gettext('フォントサイズ(SP)には単位を含んでください。(使用可能な単位：px em rem %)'), 'regex', '/^\d+\.?(\d+)?$|^\d+\.?(\d+)?(px|r?em|%)$/', $this->erchk);
    }

    /**
     * データ下書き保存処理.
     *
     * @param array $post 保存データ
     *
     * @return null|string エラー時=string
     */
    public function doSave($post)
    {
        include_once(LIB_PATH.'/common/imgmngrDB.php');
        if (!is_numeric($post['pageu_code'])) {
            return '・データの保存に失敗しました';
        }

        $post['message'] = bUtil::completionHTML($post['message']);
        $post['message_sp'] = bUtil::completionHTML($post['message_sp']);

        $unit_sync = $post['unit_sync'];
        $old_data = $this->getDetail();
        $record = null;
        foreach ($this->columns as $val) {
            if ($post[$val['column']] != null) {
                $record[$val['column']] = $post[$val['column']];
            } else {
                $record[$val['column']] = null;
            }
        }

        if (isset($post["img_del"]) && $post["img_del"] == 1) {
            $record["face_icon"] = null;
        }
        if (isset($post["img_del_sp"]) && $post["img_del_sp"] == 1) {
            $record["face_icon_sp"] = null;
        }

        if (is_numeric($record["face_icon"])) {
            $hash = "";
            $record["face_icon"] = $record["face_icon"];
            if (is_array($old_data)&& count($old_data)>0) {
                $this->_form->updateElementAttr('face_icon', array('value' => $old_data['face_icon']));
                if (file_exists(BASE_PATH.UNITS_IMG_PATH.$old_data["face_icon"])) {
                    $hash = md5_file(BASE_PATH.UNITS_IMG_PATH.$old_data["face_icon"]);
                }
            }
            $imgmngrDB = new imgmngrDB();
            $imgdata = $imgmngrDB->getImageFromCode($record["face_icon"], UNITS_IMG_PATH, $record["pageu_code"], 1);
            if (isset($imgdata)) {
                $data_path1 = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
                $img_path1 = $imgdata["gimg_src"];  // コピー先（公開用の画像パス）
                if (md5_file(BASE_PATH.$data_path1) != $hash) {
                    $record["face_icon"] = array_pop(explode('/', $img_path1)); //保存ファイル名取得
                    $cpflg1 = true;
                } else {
                    $record["face_icon"] = $old_data["face_icon"];
                }
            } else {
                return _gettext('B_P00651');
            }
        }

        if ($unit_sync == 1) {
            $record['bg_color_sp'] = $record['bg_color'];
            $record['bdr_type_sp'] = $record['bdr_type'];
            $record['btm_padding_sp'] = $record['btm_padding'];

            foreach ($record as $k=>$v) {
                if (preg_match("/(.*)_sp$/", $k, $m)) {
                    $record[$m[1].'_sp'] = $record[$m[1]];
                }
            }
        } else {
            if (isset($_POST['pc2sp']['message'])) {
                $record["message_sp"] = $record["message"];
            }
            if (isset($_POST['pc2sp']['face_icon'])) {
                $record["face_icon_sp"] = $record["face_icon"];
            } else {
                if (is_numeric($record["face_icon_sp"])) {
                    $hash = "";
                    $record["face_icon_sp"] = $record["face_icon_sp"];
                    if (is_array($old_data)&& count($old_data)>0) {
                        $this->_form->updateElementAttr('face_icon_sp', array('value' => $old_data['face_icon_sp']));
                        if (file_exists(BASE_PATH.UNITS_IMG_PATH.$old_data["face_icon_sp"])) {
                            $hash = md5_file(BASE_PATH.UNITS_IMG_PATH.$old_data["face_icon_sp"]);
                        }
                    }
                    $imgmngrDB = new imgmngrDB();
                    $imgdata = $imgmngrDB->getImageFromCode($record["face_icon_sp"], UNITS_IMG_PATH, $record["pageu_code"], 1);
                    if (isset($imgdata)) {
                        $data_path1_sp = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
                        $img_path1_sp = $imgdata["gimg_src"];  // コピー先（公開用の画像パス）
                        if (md5_file(BASE_PATH.$data_path1_sp) != $hash) {
                            $record["face_icon_sp"] = array_pop(explode('/', $img_path1_sp)); //保存ファイル名取得
                            $cpflg1_sp = true;
                        } else {
                            $record["face_icon_sp"] = $old_data["face_icon_sp"];
                        }
                    } else {
                        return _gettext('B_P00651');
                    }
                }
            }
        }

        if (is_numeric($record['face_icon_size'])) {
            $record['face_icon_size'] .= 'px';
        }
        if (is_numeric($record['face_icon_size_sp'])) {
            $record['face_icon_size_sp'] .= 'px';
        }

        $this->db->query('BEGIN');
        //保存処理開始
        if (is_array($old_data) && count($old_data) > 0) {
            //更新
            if (!$this->db->update($this->getTbl(), $record, 'pageu_code='.$record['pageu_code'])) {
                $this->db->query('ROLLBACK');

                return _gettext('B_P00209');
            }
        } else {
            //新規
            if (!$this->db->insert($this->getTbl(), $record)) {
                $this->db->query('ROLLBACK');

                return _gettext('B_P00209');
            }
        }

        // saas
        $fsize = array();
        if ($cpflg1) {
            $fsize[] = array('size' => filesize(BASE_PATH.$data_path1));
        }
        if ($cpflg1_sp) {
            $fsize[] = array('size' => filesize(BASE_PATH.$data_path1_sp));
        }
        if (count($fsize)>0 && !commonFile::chkSaveFiles($fsize)) {
            $this->db->query('ROLLBACK');
            return _gettext('B_P00281');
        }
        // ここでファイルのコピーを行う
        if ($cpflg1) {
            if (!@copy(BASE_PATH.$data_path1, BASE_PATH.$img_path1)) {
                $this->db->query('ROLLBACK');
                return _gettext('B_P00650');
            } else {
                @chmod(BASE_PATH.$img_path1, 0666);
            }
        }
        if ($cpflg1_sp) {
            if (!@copy(BASE_PATH.$data_path1_sp, BASE_PATH.$img_path1_sp)) {
                $this->db->query('ROLLBACK');
                return _gettext('B_P00650');
            } else {
                @chmod(BASE_PATH.$img_path1_sp, 0666);
            }
        }

        $this->db->query('COMMIT');

        return;
    }
}
